=== debian/changelog ===
ros-galactic-nerian-stereo (1.1.1-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 04 Jul 2022 08:45:43 -0000

ros-galactic-nerian-stereo (1.1.0-1focal) focal; urgency=high

  * Updated vision software relase to 10.0.0
  * Fixed potential problem with time sources in logging code
  * Support for Humble
  * Initiate image transfer despite any failure to connect to parameter service.
    (Device-related parameters are unavailable then - a verbose error is logged.)
  * Contributors: Konstantin Schauwecker, Ramin Yaghoubzadeh Torky

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Wed, 29 Jun 2022 22:00:00 -0000

ros-galactic-nerian-stereo (1.0.3-1focal) focal; urgency=high

  * Updated vision software release
  * fixed point cloud color channel issue with large RGB images
  * Contributors: Konstantin Schauwecker

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Mon, 28 Feb 2022 23:00:00 -0000

ros-galactic-nerian-stereo (1.0.0-1focal) focal; urgency=high

  * Initial release for ROS2

 -- Konstantin Schauwecker <konstantin.schauwecker@nerian.com>  Tue, 13 Apr 2021 22:00:00 -0000
